# -*- coding: utf-8 -*-

from direct.showbase.DirectObject import DirectObject
from pandac.PandaModules import Vec3

class cameraHandler(DirectObject):
	def __init__(self):
		base.disableMouse()
		self.mx, self.my = 0, 0
		self.dragging = False
		
		self.j1 = render.attachNewNode('cam_j1')
		self.j2 = render.attachNewNode('cam_j2')
		self.j2.setZ(5)
		self.j3 = render.attachNewNode('cam_j3')
		self.j3.setY(-40)
		
		self.accept("mouse3", self.drag,[True])
		self.accept("mouse3-up", self.drag,[False])
		self.accept("wheel_up", self.adjustCamDist, [0.9])
		self.accept("wheel_down", self.adjustCamDist, [1.1])

		taskMgr.add(self.dragTask, 'dragTask')

	def drag(self, bool):
		self.dragging = bool

	def adjustCamDist(self, aspect):
		self.j3.setY(self.j3.getY()*aspect)

	def turnCamera(self, tx, ty):
		self.j1.setH(self.j1.getH()+tx)
		self.j2.setP(self.j2.getP()-ty)
		if self.j2.getP() < -80:
			self.j2.setP(-80)
		if self.j2.getP() > -10:
			self.j2.setP(-10)
		print "x"

	def dragTask(self, task):
		if base.mouseWatcherNode.hasMouse():
			mpos = base.mouseWatcherNode.getMouse()
			if self.dragging:
				self.turnCamera((self.mx-mpos.getX())*100, (self.my-mpos.getY())*100)
			else:
				if self.my > 0.8:
					aspect = -(1-self.my-0.2)*5
					self.j1.setY(self.j1,aspect)
				if self.my < -0.8:
					aspect = (1+self.my-0.2)*5
					self.j1.setY(self.j1, aspect)
				if self.mx > 0.8:
					aspect = -(1-self.mx-0.2)*5
					self.j1.setX(self.j1, aspect)
				if self.mx < -0.8:
					aspect = (1+self.mx-0.2)*5
					self.j1.setX(self.j1, aspect)
			self.mx = mpos.getX()
			self.my = mpos.getY()
		vDir = Vec3(self.j3.getPos(render)) - Vec3(base.camera.getPos(render))
		vDir = vDir*0.2
		base.camera.setPos(Vec3(base.camera.getPos())+vDir)
		base.camera.lookAt(self.j2.getPos(render))
		return task.cont
